<template>
  <div class="app-container">

    <el-card>
      <span>外协厂家:</span>
      <el-select v-model="ManufacturerNameValue" placeholder="选择外协厂家" filterable clearable size="small" style="width:190px;margin:10px;">
        <el-option
          v-for="item in ManufacturerName"
          :key="item.value"
          :label="item.label"
          :value="item.value"/>
      </el-select>
      <el-button type="success" class="el-icon-search" size="small" @click="pageCurrent=1;pageSize=10;total=null;pageCurrent2=1;pageSize2=10;total2=null;searchTable()">查询</el-button>
    </el-card>

    <el-card>
      <el-table v-loading="loading" :data="tableData" height="400" style="width: 100%;" border highlight-current-row element-loading-text="拼命加载中" @row-click="getParts3">
        <el-table-column
          label=" "
          type="index"
          align="center"
          width="50"/>
        <el-table-column label="外协厂家" align="center" width="280px">
          <template slot-scope="scope">
            {{ scope.row.外协厂家名称 }}
          </template>
        </el-table-column>
        <el-table-column label="待付总额(元)" align="center">
          <template slot-scope="scope">
            {{ scope.row.待付金额 }}
          </template>
        </el-table-column>
        <el-table-column label="操作" align="center" width="300px" fixed="right">
          <template slot-scope="scope">
            <el-button
              size="mini"
              type="primary"
              class="el-icon-check"
              @click="editType1(scope.row, 'form');param = 0">到票</el-button>
            <el-button
              size="mini"
              type="success"
              class="el-icon-check"
              @click="payment(scope.row, 'form2');param2 = 0">付款</el-button>
          </template>
        </el-table-column>
      </el-table>
      <div class="block">
        <el-pagination
          v-if="!loading"
          :current-page="pageCurrent"
          :page-sizes="[10, 20, 30, 40]"
          :page-size="pageSize"
          :total="total"
          layout="total, sizes, prev, pager, next, jumper"
          @size-change="handleSizeChange"
          @current-change="handleCurrentChange"/>
      </div>
    </el-card>
    <el-tabs type="border-card">
      <el-tab-pane label="付款明细">
        <el-table v-loading="loading3" :data="tableData3" height="370" style="width: 100%;" border element-loading-text="拼命加载中">
          <el-table-column label="付款金额" align="center" width="230px">
            <template slot-scope="scope">
              {{ scope.row.付款金额 }}
            </template>
          </el-table-column>
          <el-table-column label="备注" align="center">
            <template slot-scope="scope">
              {{ scope.row.备注 }}
            </template>
          </el-table-column>
          <el-table-column label="付款日期" align="center">
            <template slot-scope="scope">
              {{ scope.row.付款日期 }}
            </template>
          </el-table-column>
          <el-table-column label="操作" align="center" width="200px" fixed="right">
            <template slot-scope="scope">
              <el-button size="mini" type="primary" class="el-icon-edit" @click="handleChange3(scope.row, 'form2')">编辑</el-button>
              <el-button size="mini" type="danger" class="el-icon-delete" @click="handleDelete3(scope.$index, scope.row)">删除</el-button>
            </template>
          </el-table-column>
        </el-table>
        <div class="block">
          <el-pagination
            v-if="!loading3"
            :current-page="pageCurrent3"
            :page-sizes="[10, 20, 30, 40]"
            :page-size="pageSize3"
            :total="total3"
            layout="total, sizes, prev, pager, next, jumper"
            @size-change="handleSizeChange3"
            @current-change="handleCurrentChange3"/>
        </div>
      </el-tab-pane>
      <el-tab-pane label="到票明细">
        <el-table v-loading="loading2" :data="tableData2" :summary-method="getSummaries" height="370" show-summary style="width: 100%;" border element-loading-text="拼命加载中">
          <el-table-column label="发票号" align="center" width="230px">
            <template slot-scope="scope">
              {{ scope.row.发票号 }}
            </template>
          </el-table-column>
          <el-table-column label="接收人" align="center" width="180px">
            <template slot-scope="scope">
              {{ scope.row.接收人 }}
            </template>
          </el-table-column>
          <el-table-column label="开户行" align="center">
            <template slot-scope="scope">
              {{ scope.row.开户行 }}
            </template>
          </el-table-column>
          <el-table-column label="开票金额" align="center" width="150px" prop="开票金额">
            <template slot-scope="scope">
              {{ scope.row.开票金额 }}
            </template>
          </el-table-column>
          <el-table-column label="开票日期" align="center">
            <template slot-scope="scope">
              {{ scope.row.开票时间 }}
            </template>
          </el-table-column>
          <el-table-column label="接收日期" align="center">
            <template slot-scope="scope">
              {{ scope.row.接收时间 }}
            </template>
          </el-table-column>
          <el-table-column label="备注" align="center">
            <template slot-scope="scope">
              {{ scope.row.备注 }}
            </template>
          </el-table-column>
          <el-table-column label="操作" align="center" width="200px" fixed="right">
            <template slot-scope="scope">
              <el-button size="mini" type="primary" class="el-icon-edit" @click="handleChange1(scope.$index, scope.row, 'form');param = 1">编辑</el-button>
              <el-button size="mini" type="danger" class="el-icon-delete" @click="handleDelete(scope.$index, scope.row)">删除</el-button>
            </template>
          </el-table-column>
        </el-table>
        <div class="block">
          <el-pagination
            v-if="!loading2"
            :current-page="pageCurrent2"
            :page-sizes="[10, 20, 30, 40]"
            :page-size="pageSize2"
            :total="total2"
            layout="total, sizes, prev, pager, next, jumper"
            @size-change="handleSizeChange2"
            @current-change="handleCurrentChange2"/>
        </div>
      </el-tab-pane>
    </el-tabs>

    <el-dialog :title="title1" :visible.sync="dialogFormVisible" center style="min-height: 300px" width="700px">
      <el-form ref="form" :model="form" :rules="rules" label-position="left" label-width="90px" class="demo-ruleForm">
        <el-row>
          <el-col :span="12">
            <el-form-item label="发票号" prop="发票号">
              <el-input v-model="form.发票号" placeholder="发票号" style="width:200px" clearable size="small"/>
            </el-form-item>
          </el-col>
          <el-col :span="12">
            <el-form-item label="开票金额" prop="开票金额">
              <el-input v-model="form.开票金额" placeholder="开票金额" style="width:200px" clearable size="small"/>
            </el-form-item>
          </el-col>
        </el-row>
        <el-row>
          <el-col :span="12">
            <el-form-item label="开票时间" prop="开票时间">
              <el-date-picker
                v-model="form.开票时间"
                style="width:200px"
                size="small"
                type="date"
                value-format="yyyy-MM-dd"
                format="yyyy-MM-dd"
                clearable
                placeholder="开票时间"/>
            </el-form-item>
          </el-col>
          <el-col :span="12">
            <el-form-item label="开户行" prop="开户行">
              <el-input v-model="form.开户行" placeholder="开户行" style="width:200px" clearable size="small" />
            </el-form-item>
          </el-col>
        </el-row>
        <el-row>
          <el-col :span="12">
            <el-form-item label="接收人" prop="接收人">
              <el-input v-model="form.接收人" placeholder="接收人" style="width:200px" clearable size="small"/>
            </el-form-item>
          </el-col>
          <el-col :span="12">
            <el-form-item label="接收时间" prop="接收时间">
              <el-date-picker
                v-model="form.接收时间"
                style="width:200px"
                size="small"
                type="date"
                value-format="yyyy-MM-dd"
                format="yyyy-MM-dd"
                clearable
                placeholder="接收时间"/>
            </el-form-item>
          </el-col>
        </el-row>
        <el-row>
          <el-col :span="24">
            <el-form-item label="备注" prop="备注">
              <el-input v-model="form.备注" :rows="2" placeholder="备注" type="textarea" style="width:527px" clearable size="small"/>
            </el-form-item>
          </el-col>
        </el-row>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button @click="callOff('form')">取消</el-button>
        <el-button type="primary" @click="submit('form')" >确定</el-button>
      </div>
    </el-dialog>

    <el-dialog :visible.sync="dialogFormVisible2" title="付款" center style="min-height: 300px" width="500px">
      <el-form ref="form2" :model="form2" :rules="rules" label-position="left" label-width="90px" class="demo-ruleForm">
        <el-form-item label="付款金额" prop="付款金额" style="margin-left: 80px">
          <el-input v-model="form2.付款金额" placeholder="付款金额" size="small" style="width:200px"/>
        </el-form-item>
        <el-form-item label="备注" prop="备注" style="margin-left: 80px">
          <el-input :autosize="{ minRows: 2, maxRows: 4}" v-model="form2.备注" type="textarea" placeholder="备注" size="small" style="width:200px"/>
        </el-form-item>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button @click="callOff2('form2')">取消</el-button>
        <el-button type="primary" @click="submit2('form2')">确定</el-button>
      </div>
    </el-dialog>

  </div>
</template>

<script>
import { initOutHelp, searchtable, getParts, edittype, handlechange, handledelete, getParts3, outPay, edit, handledelete3 } from '@/api/Outsourcing/OutsourcingPaymentPlanManagement2'
export default {
  data() {
    return {
      factury: '',
      fukuanshijian: '',
      title1: '',
      dialogFormVisible: false,
      renwudan: '',
      count1: 0,
      count2: 0,
      count3: 0,
      count4: 0,
      form: {
        发票号: '',
        开户行: '',
        开票时间: '',
        开票金额: '',
        接收人: '',
        接收时间: '',
        备注: ''
      },
      实际付款时间: '',
      loading: false,
      loading2: false,
      loading3: false,
      zhongjianbianliang1: '',
      zhongjianbianliang2: '',
      dialogFormVisible2: false,
      form2: {
        付款金额: '',
        备注: ''
      },
      rules: {
        发票号: [{ required: true, message: '请输入发票号', trigger: 'blur' }],
        开票金额: [{ required: true, message: '请输入开票金额', trigger: 'blur' }],
        扣款说明: [{ required: true, message: '请输入扣款说明', trigger: 'blur' }],
        付款金额: [{ required: true, message: '请输入扣款说明', trigger: 'blur' }]
      },
      date1: '',
      date2: '',
      date3: '',
      date4: '',
      FormNumber: '',
      ManufacturerNameValue: '',
      ManufacturerName: [], // 厂家名称
      FormNumber_check: false,
      ManufacturerNameValue_check: false,
      date1_check: false,
      date3_check: false,
      tableData: [], // 表格数据
      total: null, // 总条数
      pageSize: 10, // 每页显示条数
      pageCurrent: 1, // 后台获取页
      tableData2: [], // 表格数据
      total2: null, // 总条数
      pageSize2: 10, // 每页显示条数
      pageCurrent2: 1, // 后台获取页
      tableData3: [], // 表格数据
      total3: null, // 总条数
      pageSize3: 10, // 每页显示条数
      pageCurrent3: 1 // 后台获取页
    }
  },
  created() {
    this.fetchData()
    this.searchTable()
  },
  methods: {
    getSummaries(param) {
      const { columns, data } = param
      const sums = []
      columns.forEach((column, index) => {
        if (index === 0) {
          sums[index] = '总金额'
          return
        }
        const values = data.map(item => Number(item[column.property]))
        if (!values.every(value => isNaN(value))) {
          sums[index] = values.reduce((prev, curr) => {
            const value = Number(curr)
            if (!isNaN(value)) {
              return prev + curr
            } else {
              return prev
            }
          }, 0)
          sums[index] += ' 元'
        } else {
          sums[index] = ''
        }
      })
      return sums
    },
    // 初始化外协厂家
    fetchData() {
      this.ManufacturerName = []
      initOutHelp().then(response => {
        for (let i = 0; i < response.data.length; i++) {
          this.ManufacturerName.push({
            label: response.data[i].外协厂家名称,
            value: response.data[i].外协厂家流水号
          })
        }
      })
    },
    // 查询表格数据
    searchTable() {
      this.loading = true
      if (this.ManufacturerNameValue === '' || this.ManufacturerNameValue === null) {
        this.ManufacturerNameValue_check = 0
      } else {
        this.ManufacturerNameValue_check = 1
      }
      this.tableData = []
      this.tableData2 = []
      this.tableData3 = []
      searchtable(this.ManufacturerNameValue_check, this.ManufacturerNameValue, this.pageCurrent, this.pageSize).then(response => {
        this.tableData = response.data.rows
        this.total = response.data.total
      }).then(() => {
        this.loading = false
      })
    },
    getParts3(row) {
      this.loading3 = true
      this.tableData3 = []
      this.zhongjianbianliang1 = row.外协厂家流水号
      getParts3(row.外协厂家流水号, this.pageCurrent3, this.pageSize3).then(response => {
        for (let i = 0; i < response.data.rows.length; i++) {
          response.data.rows[i].付款日期 = response.data.rows[i].付款日期.split(' ')[0]
        }
        this.tableData3 = response.data.rows
        this.total3 = response.data.total
      }).then(() => {
        this.loading3 = false
      })
      this.loading2 = true
      this.tableData2 = []
      this.zhongjianbianliang2 = row.外协厂家流水号
      getParts(this.zhongjianbianliang2, this.pageCurrent2, this.pageSize2).then(response => {
        for (let i = 0; i < response.data.rows.length; i++) {
          response.data.rows[i].开票时间 = response.data.rows[i].开票时间.substring(0, response.data.rows[i].开票时间.indexOf(' '))
          response.data.rows[i].接收时间 = response.data.rows[i].接收时间.substring(0, response.data.rows[i].接收时间.indexOf(' '))
        }
        this.tableData2 = response.data.rows
        this.total2 = response.data.total
      }).then(() => {
        this.loading2 = false
      })
    },
    getParts4() {
      this.loading3 = true
      this.tableData3 = []
      getParts3(this.zhongjianbianliang1, this.pageCurrent3, this.pageSize3).then(response => {
        for (let i = 0; i < response.data.rows.length; i++) {
          response.data.rows[i].付款日期 = response.data.rows[i].付款日期.split(' ')[0]
        }
        this.tableData3 = response.data.rows
        this.total3 = response.data.total
      }).then(() => {
        this.loading3 = false
      })
    },
    // 新增付款打开
    payment(row, formName) {
      this.param2 = 0
      this.count3 = this.count3 + 1
      if (this.count3 !== 1) {
        this.$refs[formName].resetFields()
      }
      this.factury = row.外协厂家流水号
      var time = new Date()
      var month = time.getMonth() + 1
      var day = time.getDate()
      if (month >= 1 && month <= 9) {
        month = '0' + month
      }
      if (day >= 1 && day <= 9) {
        day = '0' + day
      }
      this.payDate = time.getFullYear() + '/' + month + '/' + day
      this.form2.付款金额 = ''
      this.form2.备注 = ''
      this.dialogFormVisible2 = true
    },
    // 新增付款确定
    outPay() {
      outPay(this.factury, this.form2.付款金额, this.payDate, this.form2.备注).then(response => {
        if (response.data[0].result === '1') {
          this.$message.success('信息增加成功')
          this.searchTable()
          this.getParts4()
        } else {
          this.$message.error('信息增加失败')
        }
      })
    },
    // 编辑付款打开
    handleChange3(row, formName) {
      this.param2 = 1
      this.count4 = this.count4 + 1
      if (this.count4 !== 1) {
        this.$refs[formName].resetFields()
      }
      this.factury = row.外协付款流水号
      this.form2.付款金额 = row.付款金额
      this.form2.备注 = row.备注
      this.dialogFormVisible2 = true
    },
    // 编辑付款确定
    edit() {
      edit(this.factury, this.form2.付款金额, this.form2.备注).then(response => {
        if (response.data[0].result === '1') {
          this.$message.success('信息修改成功')
          this.searchTable()
          this.getParts4()
        } else {
          this.$message.error('信息修改失败')
        }
      })
      this.dialogFormVisible = false
    },
    // 删除
    handleDelete3(index, row) {
      this.$confirm('此操作将永久删除该行, 是否继续?', '提示', {
        confirmButtonText: '确定',
        cancelButtonText: '取消',
        type: 'warning'
      }).then(() => {
        handledelete3(row.外协付款流水号).then(response => {
          if (this.tableData3 && this.tableData3.length === 1 && this.pageCurrent3 > 1) {
            this.pageCurrent3--
          }
          if (response.data[0].result === '1') {
            this.$message.success('信息删除成功')
            this.searchTable()
            this.getParts4()
          } else {
            this.$message.error('信息删除失败')
          }
        })
      }).catch(() => {
        this.$message({
          type: 'info',
          message: '已取消删除'
        })
      })
    },
    submit2(formName) {
      this.$refs[formName].validate((valid) => {
        if (valid) {
          if (this.param2 === 0) {
            this.outPay()
            this.dialogFormVisible2 = false
          } else {
            this.edit()
            this.dialogFormVisible2 = false
          }
        } else {
          return false
        }
      })
    },
    callOff2(formName) {
      this.dialogFormVisible2 = false
      this.$refs[formName].resetFields()
    },
    // 获取表格2数据
    getParts2() {
      this.loading2 = true
      this.tableData2 = []
      getParts(this.zhongjianbianliang2, this.pageCurrent2, this.pageSize2).then(response => {
        for (let i = 0; i < response.data.rows.length; i++) {
          response.data.rows[i].开票时间 = response.data.rows[i].开票时间.substring(0, response.data.rows[i].开票时间.indexOf(' '))
          response.data.rows[i].接收时间 = response.data.rows[i].接收时间.substring(0, response.data.rows[i].接收时间.indexOf(' '))
        }
        this.tableData2 = response.data.rows
        this.total2 = response.data.total
      }).then(() => {
        this.loading2 = false
      })
    },
    // 增加发票
    editType1(row, formName) {
      this.count1 = this.count1 + 1
      if (this.count1 !== 1) {
        this.$refs[formName].resetFields()
      }
      this.title1 = '增加'
      this.renwudan = row.外协厂家流水号
      this.form.发票号 = ''
      this.form.开户行 = ''
      this.form.开票时间 = ''
      this.form.开票金额 = ''
      this.form.接收人 = ''
      this.form.接收时间 = ''
      this.form.备注 = ''
      this.dialogFormVisible = true
    },
    // 增加确定
    editType() {
      edittype(this.renwudan, this.form.发票号, this.form.开户行, this.form.开票时间, this.form.开票金额, this.form.接收人, this.form.接收时间, this.form.备注).then(response => {
        if (response.data[0].result === '1') {
          this.$message.error('信息增加成功')
          this.getParts2()
        } else {
          this.$message.error('信息增加失败')
        }
      })
      this.dialogFormVisible = false
    },
    // 编辑发票
    handleChange1(index, row, formName) {
      this.count2 = this.count2 + 1
      if (this.count2 !== 1) {
        this.$refs[formName].resetFields()
      }
      this.form.发票号 = row.发票号
      this.form.开户行 = row.开户行
      this.form.开票时间 = row.开票时间
      this.form.开票金额 = row.开票金额
      this.form.接收人 = row.接收人
      this.form.接收时间 = row.接收时间
      this.form.备注 = row.备注
      this.dialogFormVisible = true
      this.title1 = '编辑'
      this.CoManufacturerFlowNumber1 = row.id
    },
    // 编辑确定
    handleChange() {
      handlechange(this.CoManufacturerFlowNumber1, this.form.发票号, this.form.开户行, this.form.开票时间, this.form.开票金额, this.form.接收人, this.form.接收时间, this.form.备注).then(response => {
        if (response.data[0].result === '1') {
          this.$message.success('信息编辑成功')
          this.getParts2()
        } else {
          this.$message.error('信息修改失败')
        }
      })
      this.dialogFormVisible = false
    },
    // 提交添加或者修改
    submit(formName) {
      this.$refs[formName].validate((valid) => {
        if (valid) {
          if (this.param === 0) {
            this.editType()
          } else {
            this.handleChange()
          }
        } else {
          return false
        }
      })
    },
    // 重置表单
    callOff(formName) {
      this.dialogFormVisible = false
      this.$refs[formName].resetFields()
    },
    // 删除
    handleDelete(index, row) {
      this.$confirm('此操作将永久删除该行, 是否继续?', '提示', {
        confirmButtonText: '确定',
        cancelButtonText: '取消',
        type: 'warning'
      }).then(() => {
        handledelete(row.id).then(response => {
          if (this.tableData2 && this.tableData2.length === 1 && this.pageCurrent2 > 1) {
            this.pageCurrent2--
          }
          if (response.data[0].result === '1') {
            this.$message.success('信息删除成功')
            this.getParts2()
          } else {
            this.$message.error('信息删除失败')
          }
        })
      }).catch(() => {
        this.$message({
          type: 'info',
          message: '已取消删除'
        })
      })
    },
    // 分页
    handleSizeChange(val) {
      this.pageCurrent = 1
      this.pageSize = val
      this.searchTable()
    },
    handleCurrentChange(val) {
      this.pageCurrent = val
      this.searchTable()
    },
    handleSizeChange2(val) {
      this.pageCurrent2 = 1
      this.pageSize2 = val
      this.getParts2()
    },
    handleCurrentChange2(val) {
      this.pageCurrent2 = val
      this.tableData2 = []
      this.getParts2()
    },
    handleSizeChange3(val) {
      this.pageCurrent3 = 1
      this.pageSize3 = val
      this.getParts3()
    },
    handleCurrentChange3(val) {
      this.pageCurrent3 = val
      this.getParts3()
    }
  }
}
</script>

<style scoped>
  .el-card{
    margin-bottom: 10px;
  }
  .el-table .fukuan {
    background: #AEF199;
  }
</style>

